/* protocol-lens-interface.c generated by valac 0.22.1, the Vala compiler
 * generated from protocol-lens-interface.vala, do not modify */

/*
 * Copyright (C) 2010 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define UNITY_PROTOCOL_TYPE_LENS_INFO (unity_protocol_lens_info_get_type ())
typedef struct _UnityProtocolLensInfo UnityProtocolLensInfo;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define UNITY_PROTOCOL_TYPE_HANDLED_TYPE (unity_protocol_handled_type_get_type ())

#define UNITY_PROTOCOL_TYPE_ACTION_TYPE (unity_protocol_action_type_get_type ())

#define UNITY_PROTOCOL_TYPE_VIEW_TYPE (unity_protocol_view_type_get_type ())

#define UNITY_PROTOCOL_TYPE_LENS_SERVICE (unity_protocol_lens_service_get_type ())
#define UNITY_PROTOCOL_LENS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_PROTOCOL_TYPE_LENS_SERVICE, UnityProtocolLensService))
#define UNITY_PROTOCOL_IS_LENS_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_PROTOCOL_TYPE_LENS_SERVICE))
#define UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNITY_PROTOCOL_TYPE_LENS_SERVICE, UnityProtocolLensServiceIface))

typedef struct _UnityProtocolLensService UnityProtocolLensService;
typedef struct _UnityProtocolLensServiceIface UnityProtocolLensServiceIface;

#define UNITY_PROTOCOL_TYPE_LENS_SERVICE_PROXY (unity_protocol_lens_service_proxy_get_type ())

#define UNITY_PROTOCOL_TYPE_ACTIVATION_REPLY_RAW (unity_protocol_activation_reply_raw_get_type ())
typedef struct _UnityProtocolActivationReplyRaw UnityProtocolActivationReplyRaw;
typedef GDBusProxy UnityProtocolLensServiceProxy;
typedef GDBusProxyClass UnityProtocolLensServiceProxyClass;

struct _UnityProtocolLensInfo {
	gchar* dbus_path;
	gboolean search_in_global;
	gboolean visible;
	gchar* search_hint;
	gchar* private_connection_name;
	gchar* results_model_name;
	gchar* global_results_model_name;
	gchar* categories_model_name;
	gchar* filters_model_name;
	GHashTable* hints;
};

typedef enum  {
	UNITY_PROTOCOL_LENS_ERROR_FAILED,
	UNITY_PROTOCOL_LENS_ERROR_INVALID_SCOPE
} UnityProtocolLensError;
#define UNITY_PROTOCOL_LENS_ERROR unity_protocol_lens_error_quark ()
typedef enum  {
	UNITY_PROTOCOL_HANDLED_TYPE_NOT_HANDLED,
	UNITY_PROTOCOL_HANDLED_TYPE_SHOW_DASH,
	UNITY_PROTOCOL_HANDLED_TYPE_HIDE_DASH,
	UNITY_PROTOCOL_HANDLED_TYPE_GOTO_DASH_URI,
	UNITY_PROTOCOL_HANDLED_TYPE_SHOW_PREVIEW
} UnityProtocolHandledType;

typedef enum  {
	UNITY_PROTOCOL_ACTION_TYPE_ACTIVATE_RESULT,
	UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_RESULT,
	UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_ACTION,
	UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_BUILTIN_ACTION
} UnityProtocolActionType;

typedef enum  {
	UNITY_PROTOCOL_VIEW_TYPE_HIDDEN,
	UNITY_PROTOCOL_VIEW_TYPE_HOME_VIEW,
	UNITY_PROTOCOL_VIEW_TYPE_LENS_VIEW
} UnityProtocolViewType;

struct _UnityProtocolActivationReplyRaw {
	gchar* uri;
	guint handled;
	GHashTable* hints;
};

struct _UnityProtocolLensServiceIface {
	GTypeInterface parent_iface;
	void (*info_request) (UnityProtocolLensService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*info_request_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
	void (*activate) (UnityProtocolLensService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
	void (*activate_with_hints) (UnityProtocolLensService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_with_hints_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
	void (*update_preview_property) (UnityProtocolLensService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*update_preview_property_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
	void (*search) (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*search_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
	void (*global_search) (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*global_search_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
	void (*update_filter) (UnityProtocolLensService* self, const gchar* filter_name, GHashTable* properties, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*update_filter_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
	void (*set_view_type) (UnityProtocolLensService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_view_type_finish) (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
};



GType unity_protocol_lens_info_get_type (void) G_GNUC_CONST;
UnityProtocolLensInfo* unity_protocol_lens_info_dup (const UnityProtocolLensInfo* self);
void unity_protocol_lens_info_free (UnityProtocolLensInfo* self);
void unity_protocol_lens_info_copy (const UnityProtocolLensInfo* self, UnityProtocolLensInfo* dest);
void unity_protocol_lens_info_destroy (UnityProtocolLensInfo* self);
GQuark unity_protocol_lens_error_quark (void);
GType unity_protocol_handled_type_get_type (void) G_GNUC_CONST;
GType unity_protocol_action_type_get_type (void) G_GNUC_CONST;
GType unity_protocol_view_type_get_type (void) G_GNUC_CONST;
GType unity_protocol_lens_service_proxy_get_type (void) G_GNUC_CONST;
guint unity_protocol_lens_service_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType unity_protocol_activation_reply_raw_get_type (void) G_GNUC_CONST;
UnityProtocolActivationReplyRaw* unity_protocol_activation_reply_raw_dup (const UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_free (UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_copy (const UnityProtocolActivationReplyRaw* self, UnityProtocolActivationReplyRaw* dest);
void unity_protocol_activation_reply_raw_destroy (UnityProtocolActivationReplyRaw* self);
GType unity_protocol_lens_service_get_type (void) G_GNUC_CONST;
void unity_protocol_lens_service_info_request (UnityProtocolLensService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_lens_service_info_request_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_lens_service_activate (UnityProtocolLensService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_lens_service_activate_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
void unity_protocol_lens_service_activate_with_hints (UnityProtocolLensService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_lens_service_activate_with_hints_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
void unity_protocol_lens_service_update_preview_property (UnityProtocolLensService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_lens_service_update_preview_property_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_lens_service_search (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_lens_service_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_lens_service_global_search (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_lens_service_global_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_lens_service_update_filter (UnityProtocolLensService* self, const gchar* filter_name, GHashTable* properties, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_lens_service_update_filter_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_lens_service_set_view_type (UnityProtocolLensService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_lens_service_set_view_type_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void unity_protocol_lens_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_unity_protocol_lens_service_changed (UnityProtocolLensService* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void unity_protocol_lens_service_proxy_info_request_async (UnityProtocolLensService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_lens_service_proxy_info_request_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_activate_async (UnityProtocolLensService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_lens_service_proxy_activate_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
static void unity_protocol_lens_service_proxy_activate_with_hints_async (UnityProtocolLensService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_lens_service_proxy_activate_with_hints_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
static void unity_protocol_lens_service_proxy_update_preview_property_async (UnityProtocolLensService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_lens_service_proxy_update_preview_property_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_search_async (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_lens_service_proxy_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_global_search_async (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_lens_service_proxy_global_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_update_filter_async (UnityProtocolLensService* self, const gchar* filter_name, GHashTable* properties, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_lens_service_proxy_update_filter_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_set_view_type_async (UnityProtocolLensService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_lens_service_proxy_set_view_type_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_lens_service_proxy_unity_protocol_lens_service_interface_init (UnityProtocolLensServiceIface* iface);
static void _dbus_unity_protocol_lens_service_info_request (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_activate (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_activate_with_hints (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_activate_with_hints_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_update_preview_property (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_search (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_global_search (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_update_filter (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_update_filter_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_lens_service_set_view_type (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_lens_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void unity_protocol_lens_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* unity_protocol_lens_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean unity_protocol_lens_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_unity_protocol_lens_service_changed (GObject* _sender, UnityProtocolLensInfo* lens_info, gpointer* _data);
static void _unity_protocol_lens_service_unregister_object (gpointer user_data);

static const GDBusErrorEntry unity_protocol_lens_error_entries[] = {{UNITY_PROTOCOL_LENS_ERROR_FAILED, "com.canonical.Unity.LensError.Failed"}, {UNITY_PROTOCOL_LENS_ERROR_INVALID_SCOPE, "com.canonical.Unity.LensError.InvalidScope"}};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_info_request_in[] = {NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_info_request_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_info_request = {-1, "InfoRequest", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_info_request_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_info_request_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_action_type = {-1, "action_type", "u"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_result = {-1, "result", "(sua{sv})"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_activate_in[] = {&_unity_protocol_lens_service_dbus_arg_info_activate_uri, &_unity_protocol_lens_service_dbus_arg_info_activate_action_type, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_activate_out[] = {&_unity_protocol_lens_service_dbus_arg_info_activate_result, NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_activate = {-1, "Activate", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_activate_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_activate_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_action_type = {-1, "action_type", "u"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_result = {-1, "result", "(sua{sv})"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_in[] = {&_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_uri, &_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_action_type, &_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_activate_with_hints_out[] = {&_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_result, NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_activate_with_hints = {-1, "ActivateWithHints", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_activate_with_hints_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_update_preview_property_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_update_preview_property_values = {-1, "values", "a{sv}"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_update_preview_property_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_update_preview_property_in[] = {&_unity_protocol_lens_service_dbus_arg_info_update_preview_property_uri, &_unity_protocol_lens_service_dbus_arg_info_update_preview_property_values, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_update_preview_property_out[] = {&_unity_protocol_lens_service_dbus_arg_info_update_preview_property_result, NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_update_preview_property = {-1, "UpdatePreviewProperty", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_update_preview_property_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_update_preview_property_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_search_in[] = {&_unity_protocol_lens_service_dbus_arg_info_search_search_string, &_unity_protocol_lens_service_dbus_arg_info_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_search_out[] = {&_unity_protocol_lens_service_dbus_arg_info_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_search = {-1, "Search", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_search_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_search_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_global_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_global_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_global_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_global_search_in[] = {&_unity_protocol_lens_service_dbus_arg_info_global_search_search_string, &_unity_protocol_lens_service_dbus_arg_info_global_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_global_search_out[] = {&_unity_protocol_lens_service_dbus_arg_info_global_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_global_search = {-1, "GlobalSearch", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_global_search_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_global_search_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_update_filter_filter_name = {-1, "filter_name", "s"};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_update_filter_properties = {-1, "properties", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_update_filter_in[] = {&_unity_protocol_lens_service_dbus_arg_info_update_filter_filter_name, &_unity_protocol_lens_service_dbus_arg_info_update_filter_properties, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_update_filter_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_update_filter = {-1, "UpdateFilter", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_update_filter_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_update_filter_out)};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_set_view_type_view_type = {-1, "view_type", "u"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_set_view_type_in[] = {&_unity_protocol_lens_service_dbus_arg_info_set_view_type_view_type, NULL};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_set_view_type_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_lens_service_dbus_method_info_set_view_type = {-1, "SetViewType", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_set_view_type_in), (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_set_view_type_out)};
static const GDBusMethodInfo * const _unity_protocol_lens_service_dbus_method_info[] = {&_unity_protocol_lens_service_dbus_method_info_info_request, &_unity_protocol_lens_service_dbus_method_info_activate, &_unity_protocol_lens_service_dbus_method_info_activate_with_hints, &_unity_protocol_lens_service_dbus_method_info_update_preview_property, &_unity_protocol_lens_service_dbus_method_info_search, &_unity_protocol_lens_service_dbus_method_info_global_search, &_unity_protocol_lens_service_dbus_method_info_update_filter, &_unity_protocol_lens_service_dbus_method_info_set_view_type, NULL};
static const GDBusArgInfo _unity_protocol_lens_service_dbus_arg_info_changed_lens_info = {-1, "lens_info", "(sbbssssssa{sv})"};
static const GDBusArgInfo * const _unity_protocol_lens_service_dbus_arg_info_changed[] = {&_unity_protocol_lens_service_dbus_arg_info_changed_lens_info, NULL};
static const GDBusSignalInfo _unity_protocol_lens_service_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_unity_protocol_lens_service_dbus_arg_info_changed)};
static const GDBusSignalInfo * const _unity_protocol_lens_service_dbus_signal_info[] = {&_unity_protocol_lens_service_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo * const _unity_protocol_lens_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _unity_protocol_lens_service_dbus_interface_info = {-1, "com.canonical.Unity.Lens", (GDBusMethodInfo **) (&_unity_protocol_lens_service_dbus_method_info), (GDBusSignalInfo **) (&_unity_protocol_lens_service_dbus_signal_info), (GDBusPropertyInfo **) (&_unity_protocol_lens_service_dbus_property_info)};
static const GDBusInterfaceVTable _unity_protocol_lens_service_dbus_interface_vtable = {unity_protocol_lens_service_dbus_interface_method_call, unity_protocol_lens_service_dbus_interface_get_property, unity_protocol_lens_service_dbus_interface_set_property};

static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


void unity_protocol_lens_info_copy (const UnityProtocolLensInfo* self, UnityProtocolLensInfo* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	GHashTable* _tmp16_ = NULL;
	GHashTable* _tmp17_ = NULL;
	_tmp0_ = (*self).dbus_path;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).dbus_path);
	(*dest).dbus_path = _tmp1_;
	_tmp2_ = (*self).search_in_global;
	(*dest).search_in_global = _tmp2_;
	_tmp3_ = (*self).visible;
	(*dest).visible = _tmp3_;
	_tmp4_ = (*self).search_hint;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).search_hint);
	(*dest).search_hint = _tmp5_;
	_tmp6_ = (*self).private_connection_name;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).private_connection_name);
	(*dest).private_connection_name = _tmp7_;
	_tmp8_ = (*self).results_model_name;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*dest).results_model_name);
	(*dest).results_model_name = _tmp9_;
	_tmp10_ = (*self).global_results_model_name;
	_tmp11_ = g_strdup (_tmp10_);
	_g_free0 ((*dest).global_results_model_name);
	(*dest).global_results_model_name = _tmp11_;
	_tmp12_ = (*self).categories_model_name;
	_tmp13_ = g_strdup (_tmp12_);
	_g_free0 ((*dest).categories_model_name);
	(*dest).categories_model_name = _tmp13_;
	_tmp14_ = (*self).filters_model_name;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 ((*dest).filters_model_name);
	(*dest).filters_model_name = _tmp15_;
	_tmp16_ = (*self).hints;
	_tmp17_ = _g_hash_table_ref0 (_tmp16_);
	_g_hash_table_unref0 ((*dest).hints);
	(*dest).hints = _tmp17_;
}


void unity_protocol_lens_info_destroy (UnityProtocolLensInfo* self) {
	_g_free0 ((*self).dbus_path);
	_g_free0 ((*self).search_hint);
	_g_free0 ((*self).private_connection_name);
	_g_free0 ((*self).results_model_name);
	_g_free0 ((*self).global_results_model_name);
	_g_free0 ((*self).categories_model_name);
	_g_free0 ((*self).filters_model_name);
	_g_hash_table_unref0 ((*self).hints);
}


UnityProtocolLensInfo* unity_protocol_lens_info_dup (const UnityProtocolLensInfo* self) {
	UnityProtocolLensInfo* dup;
	dup = g_new0 (UnityProtocolLensInfo, 1);
	unity_protocol_lens_info_copy (self, dup);
	return dup;
}


void unity_protocol_lens_info_free (UnityProtocolLensInfo* self) {
	unity_protocol_lens_info_destroy (self);
	g_free (self);
}


GType unity_protocol_lens_info_get_type (void) {
	static volatile gsize unity_protocol_lens_info_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_lens_info_type_id__volatile)) {
		GType unity_protocol_lens_info_type_id;
		unity_protocol_lens_info_type_id = g_boxed_type_register_static ("UnityProtocolLensInfo", (GBoxedCopyFunc) unity_protocol_lens_info_dup, (GBoxedFreeFunc) unity_protocol_lens_info_free);
		g_once_init_leave (&unity_protocol_lens_info_type_id__volatile, unity_protocol_lens_info_type_id);
	}
	return unity_protocol_lens_info_type_id__volatile;
}


GQuark unity_protocol_lens_error_quark (void) {
	static volatile gsize unity_protocol_lens_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("unity_protocol_lens_error-quark", &unity_protocol_lens_error_quark_volatile, unity_protocol_lens_error_entries, G_N_ELEMENTS (unity_protocol_lens_error_entries));
	return (GQuark) unity_protocol_lens_error_quark_volatile;
}


GType unity_protocol_handled_type_get_type (void) {
	static volatile gsize unity_protocol_handled_type_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_handled_type_type_id__volatile)) {
		static const GEnumValue values[] = {{UNITY_PROTOCOL_HANDLED_TYPE_NOT_HANDLED, "UNITY_PROTOCOL_HANDLED_TYPE_NOT_HANDLED", "not-handled"}, {UNITY_PROTOCOL_HANDLED_TYPE_SHOW_DASH, "UNITY_PROTOCOL_HANDLED_TYPE_SHOW_DASH", "show-dash"}, {UNITY_PROTOCOL_HANDLED_TYPE_HIDE_DASH, "UNITY_PROTOCOL_HANDLED_TYPE_HIDE_DASH", "hide-dash"}, {UNITY_PROTOCOL_HANDLED_TYPE_GOTO_DASH_URI, "UNITY_PROTOCOL_HANDLED_TYPE_GOTO_DASH_URI", "goto-dash-uri"}, {UNITY_PROTOCOL_HANDLED_TYPE_SHOW_PREVIEW, "UNITY_PROTOCOL_HANDLED_TYPE_SHOW_PREVIEW", "show-preview"}, {0, NULL, NULL}};
		GType unity_protocol_handled_type_type_id;
		unity_protocol_handled_type_type_id = g_enum_register_static ("UnityProtocolHandledType", values);
		g_once_init_leave (&unity_protocol_handled_type_type_id__volatile, unity_protocol_handled_type_type_id);
	}
	return unity_protocol_handled_type_type_id__volatile;
}


GType unity_protocol_action_type_get_type (void) {
	static volatile gsize unity_protocol_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{UNITY_PROTOCOL_ACTION_TYPE_ACTIVATE_RESULT, "UNITY_PROTOCOL_ACTION_TYPE_ACTIVATE_RESULT", "activate-result"}, {UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_RESULT, "UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_RESULT", "preview-result"}, {UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_ACTION, "UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_ACTION", "preview-action"}, {UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_BUILTIN_ACTION, "UNITY_PROTOCOL_ACTION_TYPE_PREVIEW_BUILTIN_ACTION", "preview-builtin-action"}, {0, NULL, NULL}};
		GType unity_protocol_action_type_type_id;
		unity_protocol_action_type_type_id = g_enum_register_static ("UnityProtocolActionType", values);
		g_once_init_leave (&unity_protocol_action_type_type_id__volatile, unity_protocol_action_type_type_id);
	}
	return unity_protocol_action_type_type_id__volatile;
}


GType unity_protocol_view_type_get_type (void) {
	static volatile gsize unity_protocol_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_view_type_type_id__volatile)) {
		static const GEnumValue values[] = {{UNITY_PROTOCOL_VIEW_TYPE_HIDDEN, "UNITY_PROTOCOL_VIEW_TYPE_HIDDEN", "hidden"}, {UNITY_PROTOCOL_VIEW_TYPE_HOME_VIEW, "UNITY_PROTOCOL_VIEW_TYPE_HOME_VIEW", "home-view"}, {UNITY_PROTOCOL_VIEW_TYPE_LENS_VIEW, "UNITY_PROTOCOL_VIEW_TYPE_LENS_VIEW", "lens-view"}, {0, NULL, NULL}};
		GType unity_protocol_view_type_type_id;
		unity_protocol_view_type_type_id = g_enum_register_static ("UnityProtocolViewType", values);
		g_once_init_leave (&unity_protocol_view_type_type_id__volatile, unity_protocol_view_type_type_id);
	}
	return unity_protocol_view_type_type_id__volatile;
}


void unity_protocol_lens_service_info_request (UnityProtocolLensService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->info_request (self, _callback_, _user_data_);
}


void unity_protocol_lens_service_info_request_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->info_request_finish (self, _res_, error);
}


void unity_protocol_lens_service_activate (UnityProtocolLensService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->activate (self, uri, action_type, _callback_, _user_data_);
}


void unity_protocol_lens_service_activate_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->activate_finish (self, _res_, result, error);
}


void unity_protocol_lens_service_activate_with_hints (UnityProtocolLensService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->activate_with_hints (self, uri, action_type, hints, _callback_, _user_data_);
}


void unity_protocol_lens_service_activate_with_hints_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->activate_with_hints_finish (self, _res_, result, error);
}


void unity_protocol_lens_service_update_preview_property (UnityProtocolLensService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->update_preview_property (self, uri, values, _callback_, _user_data_);
}


GHashTable* unity_protocol_lens_service_update_preview_property_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->update_preview_property_finish (self, _res_, error);
}


void unity_protocol_lens_service_search (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_lens_service_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->search_finish (self, _res_, error);
}


void unity_protocol_lens_service_global_search (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->global_search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_lens_service_global_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->global_search_finish (self, _res_, error);
}


void unity_protocol_lens_service_update_filter (UnityProtocolLensService* self, const gchar* filter_name, GHashTable* properties, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->update_filter (self, filter_name, properties, _callback_, _user_data_);
}


void unity_protocol_lens_service_update_filter_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->update_filter_finish (self, _res_, error);
}


void unity_protocol_lens_service_set_view_type (UnityProtocolLensService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->set_view_type (self, view_type, _callback_, _user_data_);
}


void unity_protocol_lens_service_set_view_type_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_LENS_SERVICE_GET_INTERFACE (self)->set_view_type_finish (self, _res_, error);
}


static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), data2);
}


static void unity_protocol_lens_service_base_init (UnityProtocolLensServiceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("changed", UNITY_PROTOCOL_TYPE_LENS_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, UNITY_PROTOCOL_TYPE_LENS_INFO);
	}
}


/**
 * LensService:
 *
 * The Lens interface exported on DBus
 */
GType unity_protocol_lens_service_get_type (void) {
	static volatile gsize unity_protocol_lens_service_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_lens_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityProtocolLensServiceIface), (GBaseInitFunc) unity_protocol_lens_service_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_protocol_lens_service_type_id;
		unity_protocol_lens_service_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityProtocolLensService", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_protocol_lens_service_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (unity_protocol_lens_service_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) unity_protocol_lens_service_proxy_get_type);
		g_type_set_qdata (unity_protocol_lens_service_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.canonical.Unity.Lens");
		g_type_set_qdata (unity_protocol_lens_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) unity_protocol_lens_service_register_object);
		g_once_init_leave (&unity_protocol_lens_service_type_id__volatile, unity_protocol_lens_service_type_id);
	}
	return unity_protocol_lens_service_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (UnityProtocolLensServiceProxy, unity_protocol_lens_service_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UNITY_PROTOCOL_TYPE_LENS_SERVICE, unity_protocol_lens_service_proxy_unity_protocol_lens_service_interface_init) )
static void unity_protocol_lens_service_proxy_class_init (UnityProtocolLensServiceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = unity_protocol_lens_service_proxy_g_signal;
}


static void _dbus_handle_unity_protocol_lens_service_changed (UnityProtocolLensService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	UnityProtocolLensInfo lens_info = {0};
	GVariant* _tmp0_;
	UnityProtocolLensInfo _tmp1_;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GHashTable* _tmp13_;
	GVariantIter _tmp14_;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	g_variant_iter_init (&_tmp2_, _tmp0_);
	_tmp3_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.dbus_path = g_variant_dup_string (_tmp3_, NULL);
	g_variant_unref (_tmp3_);
	_tmp4_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.search_in_global = g_variant_get_boolean (_tmp4_);
	g_variant_unref (_tmp4_);
	_tmp5_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.visible = g_variant_get_boolean (_tmp5_);
	g_variant_unref (_tmp5_);
	_tmp6_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.search_hint = g_variant_dup_string (_tmp6_, NULL);
	g_variant_unref (_tmp6_);
	_tmp7_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.private_connection_name = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.results_model_name = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	_tmp9_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.global_results_model_name = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	_tmp10_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.categories_model_name = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	_tmp11_ = g_variant_iter_next_value (&_tmp2_);
	_tmp1_.filters_model_name = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	_tmp12_ = g_variant_iter_next_value (&_tmp2_);
	_tmp13_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp14_, _tmp12_);
	while (g_variant_iter_loop (&_tmp14_, "{?*}", &_tmp15_, &_tmp16_)) {
		g_hash_table_insert (_tmp13_, g_variant_dup_string (_tmp15_, NULL), g_variant_get_variant (_tmp16_));
	}
	_tmp1_.hints = _tmp13_;
	g_variant_unref (_tmp12_);
	lens_info = _tmp1_;
	g_variant_unref (_tmp0_);
	g_signal_emit_by_name (self, "changed", &lens_info);
	unity_protocol_lens_info_destroy (&lens_info);
}


static void unity_protocol_lens_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_unity_protocol_lens_service_changed ((UnityProtocolLensService*) proxy, parameters);
	}
}


static void unity_protocol_lens_service_proxy_init (UnityProtocolLensServiceProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void unity_protocol_lens_service_proxy_info_request_async (UnityProtocolLensService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "InfoRequest");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_lens_service_proxy_info_request_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_proxy_activate_async (UnityProtocolLensService* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	UNITY_PROTOCOL_LENS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "Activate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action_type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_lens_service_proxy_activate_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GVariant* _tmp17_;
	UnityProtocolActivationReplyRaw _tmp18_;
	GVariantIter _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	GVariant* _tmp22_;
	GHashTable* _tmp23_;
	GVariantIter _tmp24_;
	GVariant* _tmp25_;
	GVariant* _tmp26_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp17_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp19_, _tmp17_);
	_tmp20_ = g_variant_iter_next_value (&_tmp19_);
	_tmp18_.uri = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	_tmp21_ = g_variant_iter_next_value (&_tmp19_);
	_tmp18_.handled = g_variant_get_uint32 (_tmp21_);
	g_variant_unref (_tmp21_);
	_tmp22_ = g_variant_iter_next_value (&_tmp19_);
	_tmp23_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp24_, _tmp22_);
	while (g_variant_iter_loop (&_tmp24_, "{?*}", &_tmp25_, &_tmp26_)) {
		g_hash_table_insert (_tmp23_, g_variant_dup_string (_tmp25_, NULL), g_variant_get_variant (_tmp26_));
	}
	_tmp18_.hints = _tmp23_;
	g_variant_unref (_tmp22_);
	*result = _tmp18_;
	g_variant_unref (_tmp17_);
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_proxy_activate_with_hints_async (UnityProtocolLensService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp27_;
	GHashTableIter _tmp28_;
	gpointer _tmp29_;
	gpointer _tmp30_;
	G_IO_ERROR;
	UNITY_PROTOCOL_LENS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "ActivateWithHints");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action_type));
	g_hash_table_iter_init (&_tmp28_, hints);
	g_variant_builder_init (&_tmp27_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp28_, &_tmp29_, &_tmp30_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp29_;
		_value = (GVariant*) _tmp30_;
		g_variant_builder_add (&_tmp27_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp27_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_lens_service_proxy_activate_with_hints_finish (UnityProtocolLensService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GVariant* _tmp31_;
	UnityProtocolActivationReplyRaw _tmp32_;
	GVariantIter _tmp33_;
	GVariant* _tmp34_;
	GVariant* _tmp35_;
	GVariant* _tmp36_;
	GHashTable* _tmp37_;
	GVariantIter _tmp38_;
	GVariant* _tmp39_;
	GVariant* _tmp40_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp31_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp33_, _tmp31_);
	_tmp34_ = g_variant_iter_next_value (&_tmp33_);
	_tmp32_.uri = g_variant_dup_string (_tmp34_, NULL);
	g_variant_unref (_tmp34_);
	_tmp35_ = g_variant_iter_next_value (&_tmp33_);
	_tmp32_.handled = g_variant_get_uint32 (_tmp35_);
	g_variant_unref (_tmp35_);
	_tmp36_ = g_variant_iter_next_value (&_tmp33_);
	_tmp37_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp38_, _tmp36_);
	while (g_variant_iter_loop (&_tmp38_, "{?*}", &_tmp39_, &_tmp40_)) {
		g_hash_table_insert (_tmp37_, g_variant_dup_string (_tmp39_, NULL), g_variant_get_variant (_tmp40_));
	}
	_tmp32_.hints = _tmp37_;
	g_variant_unref (_tmp36_);
	*result = _tmp32_;
	g_variant_unref (_tmp31_);
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_proxy_update_preview_property_async (UnityProtocolLensService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp41_;
	GHashTableIter _tmp42_;
	gpointer _tmp43_;
	gpointer _tmp44_;
	G_IO_ERROR;
	UNITY_PROTOCOL_LENS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "UpdatePreviewProperty");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_hash_table_iter_init (&_tmp42_, values);
	g_variant_builder_init (&_tmp41_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp42_, &_tmp43_, &_tmp44_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp43_;
		_value = (GVariant*) _tmp44_;
		g_variant_builder_add (&_tmp41_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp41_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_lens_service_proxy_update_preview_property_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp45_;
	GHashTable* _tmp46_;
	GVariantIter _tmp47_;
	GVariant* _tmp48_;
	GVariant* _tmp49_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp45_ = g_variant_iter_next_value (&_reply_iter);
	_tmp46_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp47_, _tmp45_);
	while (g_variant_iter_loop (&_tmp47_, "{?*}", &_tmp48_, &_tmp49_)) {
		g_hash_table_insert (_tmp46_, g_variant_dup_string (_tmp48_, NULL), g_variant_get_variant (_tmp49_));
	}
	_result = _tmp46_;
	g_variant_unref (_tmp45_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_lens_service_proxy_search_async (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp50_;
	GHashTableIter _tmp51_;
	gpointer _tmp52_;
	gpointer _tmp53_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "Search");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp51_, hints);
	g_variant_builder_init (&_tmp50_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp51_, &_tmp52_, &_tmp53_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp52_;
		_value = (GVariant*) _tmp53_;
		g_variant_builder_add (&_tmp50_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp50_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_lens_service_proxy_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp54_;
	GHashTable* _tmp55_;
	GVariantIter _tmp56_;
	GVariant* _tmp57_;
	GVariant* _tmp58_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp54_ = g_variant_iter_next_value (&_reply_iter);
	_tmp55_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp56_, _tmp54_);
	while (g_variant_iter_loop (&_tmp56_, "{?*}", &_tmp57_, &_tmp58_)) {
		g_hash_table_insert (_tmp55_, g_variant_dup_string (_tmp57_, NULL), g_variant_get_variant (_tmp58_));
	}
	_result = _tmp55_;
	g_variant_unref (_tmp54_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_lens_service_proxy_global_search_async (UnityProtocolLensService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp59_;
	GHashTableIter _tmp60_;
	gpointer _tmp61_;
	gpointer _tmp62_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "GlobalSearch");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp60_, hints);
	g_variant_builder_init (&_tmp59_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp60_, &_tmp61_, &_tmp62_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp61_;
		_value = (GVariant*) _tmp62_;
		g_variant_builder_add (&_tmp59_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp59_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_lens_service_proxy_global_search_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp63_;
	GHashTable* _tmp64_;
	GVariantIter _tmp65_;
	GVariant* _tmp66_;
	GVariant* _tmp67_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp63_ = g_variant_iter_next_value (&_reply_iter);
	_tmp64_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp65_, _tmp63_);
	while (g_variant_iter_loop (&_tmp65_, "{?*}", &_tmp66_, &_tmp67_)) {
		g_hash_table_insert (_tmp64_, g_variant_dup_string (_tmp66_, NULL), g_variant_get_variant (_tmp67_));
	}
	_result = _tmp64_;
	g_variant_unref (_tmp63_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_lens_service_proxy_update_filter_async (UnityProtocolLensService* self, const gchar* filter_name, GHashTable* properties, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp68_;
	GHashTableIter _tmp69_;
	gpointer _tmp70_;
	gpointer _tmp71_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "UpdateFilter");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (filter_name));
	g_hash_table_iter_init (&_tmp69_, properties);
	g_variant_builder_init (&_tmp68_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp69_, &_tmp70_, &_tmp71_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp70_;
		_value = (GVariant*) _tmp71_;
		g_variant_builder_add (&_tmp68_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp68_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_lens_service_proxy_update_filter_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_proxy_set_view_type_async (UnityProtocolLensService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Lens", "SetViewType");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (view_type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_lens_service_proxy_set_view_type_finish (UnityProtocolLensService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_proxy_unity_protocol_lens_service_interface_init (UnityProtocolLensServiceIface* iface) {
	iface->info_request = unity_protocol_lens_service_proxy_info_request_async;
	iface->info_request_finish = unity_protocol_lens_service_proxy_info_request_finish;
	iface->activate = unity_protocol_lens_service_proxy_activate_async;
	iface->activate_finish = unity_protocol_lens_service_proxy_activate_finish;
	iface->activate_with_hints = unity_protocol_lens_service_proxy_activate_with_hints_async;
	iface->activate_with_hints_finish = unity_protocol_lens_service_proxy_activate_with_hints_finish;
	iface->update_preview_property = unity_protocol_lens_service_proxy_update_preview_property_async;
	iface->update_preview_property_finish = unity_protocol_lens_service_proxy_update_preview_property_finish;
	iface->search = unity_protocol_lens_service_proxy_search_async;
	iface->search_finish = unity_protocol_lens_service_proxy_search_finish;
	iface->global_search = unity_protocol_lens_service_proxy_global_search_async;
	iface->global_search_finish = unity_protocol_lens_service_proxy_global_search_finish;
	iface->update_filter = unity_protocol_lens_service_proxy_update_filter_async;
	iface->update_filter_finish = unity_protocol_lens_service_proxy_update_filter_finish;
	iface->set_view_type = unity_protocol_lens_service_proxy_set_view_type_async;
	iface->set_view_type_finish = unity_protocol_lens_service_proxy_set_view_type_finish;
}


static void _dbus_unity_protocol_lens_service_info_request (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	unity_protocol_lens_service_info_request (self, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_info_request_ready, invocation);
}


static void _dbus_unity_protocol_lens_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_lens_service_info_request_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_activate (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp72_;
	guint action_type = 0U;
	GVariant* _tmp73_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp72_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp72_, NULL);
	g_variant_unref (_tmp72_);
	_tmp73_ = g_variant_iter_next_value (&_arguments_iter);
	action_type = g_variant_get_uint32 (_tmp73_);
	g_variant_unref (_tmp73_);
	unity_protocol_lens_service_activate (self, uri, action_type, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_activate_ready, invocation);
	_g_free0 (uri);
}


static void _dbus_unity_protocol_lens_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	UnityProtocolActivationReplyRaw result = {0};
	GVariantBuilder _tmp74_;
	GVariantBuilder _tmp75_;
	GHashTableIter _tmp76_;
	gpointer _tmp77_;
	gpointer _tmp78_;
	invocation = _user_data_;
	unity_protocol_lens_service_activate_finish ((UnityProtocolLensService*) source_object, _res_, &result, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp74_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp74_, g_variant_new_string (result.uri));
	g_variant_builder_add_value (&_tmp74_, g_variant_new_uint32 (result.handled));
	g_hash_table_iter_init (&_tmp76_, result.hints);
	g_variant_builder_init (&_tmp75_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp76_, &_tmp77_, &_tmp78_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp77_;
		_value = (GVariant*) _tmp78_;
		g_variant_builder_add (&_tmp75_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp74_, g_variant_builder_end (&_tmp75_));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp74_));
	unity_protocol_activation_reply_raw_destroy (&result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_activate_with_hints (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp79_;
	guint action_type = 0U;
	GVariant* _tmp80_;
	GHashTable* hints = NULL;
	GVariant* _tmp81_;
	GHashTable* _tmp82_;
	GVariantIter _tmp83_;
	GVariant* _tmp84_;
	GVariant* _tmp85_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp79_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp79_, NULL);
	g_variant_unref (_tmp79_);
	_tmp80_ = g_variant_iter_next_value (&_arguments_iter);
	action_type = g_variant_get_uint32 (_tmp80_);
	g_variant_unref (_tmp80_);
	_tmp81_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp82_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp83_, _tmp81_);
	while (g_variant_iter_loop (&_tmp83_, "{?*}", &_tmp84_, &_tmp85_)) {
		g_hash_table_insert (_tmp82_, g_variant_dup_string (_tmp84_, NULL), g_variant_get_variant (_tmp85_));
	}
	hints = _tmp82_;
	g_variant_unref (_tmp81_);
	unity_protocol_lens_service_activate_with_hints (self, uri, action_type, hints, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_activate_with_hints_ready, invocation);
	_g_free0 (uri);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_lens_service_activate_with_hints_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	UnityProtocolActivationReplyRaw result = {0};
	GVariantBuilder _tmp86_;
	GVariantBuilder _tmp87_;
	GHashTableIter _tmp88_;
	gpointer _tmp89_;
	gpointer _tmp90_;
	invocation = _user_data_;
	unity_protocol_lens_service_activate_with_hints_finish ((UnityProtocolLensService*) source_object, _res_, &result, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp86_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp86_, g_variant_new_string (result.uri));
	g_variant_builder_add_value (&_tmp86_, g_variant_new_uint32 (result.handled));
	g_hash_table_iter_init (&_tmp88_, result.hints);
	g_variant_builder_init (&_tmp87_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp88_, &_tmp89_, &_tmp90_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp89_;
		_value = (GVariant*) _tmp90_;
		g_variant_builder_add (&_tmp87_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp86_, g_variant_builder_end (&_tmp87_));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp86_));
	unity_protocol_activation_reply_raw_destroy (&result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_update_preview_property (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp91_;
	GHashTable* values = NULL;
	GVariant* _tmp92_;
	GHashTable* _tmp93_;
	GVariantIter _tmp94_;
	GVariant* _tmp95_;
	GVariant* _tmp96_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp91_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp91_, NULL);
	g_variant_unref (_tmp91_);
	_tmp92_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp93_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp94_, _tmp92_);
	while (g_variant_iter_loop (&_tmp94_, "{?*}", &_tmp95_, &_tmp96_)) {
		g_hash_table_insert (_tmp93_, g_variant_dup_string (_tmp95_, NULL), g_variant_get_variant (_tmp96_));
	}
	values = _tmp93_;
	g_variant_unref (_tmp92_);
	unity_protocol_lens_service_update_preview_property (self, uri, values, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_update_preview_property_ready, invocation);
	_g_free0 (uri);
	_g_hash_table_unref0 (values);
}


static void _dbus_unity_protocol_lens_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp97_;
	GHashTableIter _tmp98_;
	gpointer _tmp99_;
	gpointer _tmp100_;
	invocation = _user_data_;
	result = unity_protocol_lens_service_update_preview_property_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp98_, result);
	g_variant_builder_init (&_tmp97_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp98_, &_tmp99_, &_tmp100_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp99_;
		_value = (GVariant*) _tmp100_;
		g_variant_builder_add (&_tmp97_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp97_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_search (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp101_;
	GHashTable* hints = NULL;
	GVariant* _tmp102_;
	GHashTable* _tmp103_;
	GVariantIter _tmp104_;
	GVariant* _tmp105_;
	GVariant* _tmp106_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp101_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp101_, NULL);
	g_variant_unref (_tmp101_);
	_tmp102_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp103_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp104_, _tmp102_);
	while (g_variant_iter_loop (&_tmp104_, "{?*}", &_tmp105_, &_tmp106_)) {
		g_hash_table_insert (_tmp103_, g_variant_dup_string (_tmp105_, NULL), g_variant_get_variant (_tmp106_));
	}
	hints = _tmp103_;
	g_variant_unref (_tmp102_);
	unity_protocol_lens_service_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_lens_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp107_;
	GHashTableIter _tmp108_;
	gpointer _tmp109_;
	gpointer _tmp110_;
	invocation = _user_data_;
	result = unity_protocol_lens_service_search_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp108_, result);
	g_variant_builder_init (&_tmp107_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp108_, &_tmp109_, &_tmp110_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp109_;
		_value = (GVariant*) _tmp110_;
		g_variant_builder_add (&_tmp107_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp107_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_global_search (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp111_;
	GHashTable* hints = NULL;
	GVariant* _tmp112_;
	GHashTable* _tmp113_;
	GVariantIter _tmp114_;
	GVariant* _tmp115_;
	GVariant* _tmp116_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp111_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp111_, NULL);
	g_variant_unref (_tmp111_);
	_tmp112_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp113_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp114_, _tmp112_);
	while (g_variant_iter_loop (&_tmp114_, "{?*}", &_tmp115_, &_tmp116_)) {
		g_hash_table_insert (_tmp113_, g_variant_dup_string (_tmp115_, NULL), g_variant_get_variant (_tmp116_));
	}
	hints = _tmp113_;
	g_variant_unref (_tmp112_);
	unity_protocol_lens_service_global_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_global_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_lens_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp117_;
	GHashTableIter _tmp118_;
	gpointer _tmp119_;
	gpointer _tmp120_;
	invocation = _user_data_;
	result = unity_protocol_lens_service_global_search_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp118_, result);
	g_variant_builder_init (&_tmp117_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp118_, &_tmp119_, &_tmp120_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp119_;
		_value = (GVariant*) _tmp120_;
		g_variant_builder_add (&_tmp117_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp117_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_update_filter (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* filter_name = NULL;
	GVariant* _tmp121_;
	GHashTable* properties = NULL;
	GVariant* _tmp122_;
	GHashTable* _tmp123_;
	GVariantIter _tmp124_;
	GVariant* _tmp125_;
	GVariant* _tmp126_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp121_ = g_variant_iter_next_value (&_arguments_iter);
	filter_name = g_variant_dup_string (_tmp121_, NULL);
	g_variant_unref (_tmp121_);
	_tmp122_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp123_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp124_, _tmp122_);
	while (g_variant_iter_loop (&_tmp124_, "{?*}", &_tmp125_, &_tmp126_)) {
		g_hash_table_insert (_tmp123_, g_variant_dup_string (_tmp125_, NULL), g_variant_get_variant (_tmp126_));
	}
	properties = _tmp123_;
	g_variant_unref (_tmp122_);
	unity_protocol_lens_service_update_filter (self, filter_name, properties, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_update_filter_ready, invocation);
	_g_free0 (filter_name);
	_g_hash_table_unref0 (properties);
}


static void _dbus_unity_protocol_lens_service_update_filter_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_lens_service_update_filter_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_lens_service_set_view_type (UnityProtocolLensService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	guint view_type = 0U;
	GVariant* _tmp127_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp127_ = g_variant_iter_next_value (&_arguments_iter);
	view_type = g_variant_get_uint32 (_tmp127_);
	g_variant_unref (_tmp127_);
	unity_protocol_lens_service_set_view_type (self, view_type, (GAsyncReadyCallback) _dbus_unity_protocol_lens_service_set_view_type_ready, invocation);
}


static void _dbus_unity_protocol_lens_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_lens_service_set_view_type_finish ((UnityProtocolLensService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void unity_protocol_lens_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "InfoRequest") == 0) {
		_dbus_unity_protocol_lens_service_info_request (object, parameters, invocation);
	} else if (strcmp (method_name, "Activate") == 0) {
		_dbus_unity_protocol_lens_service_activate (object, parameters, invocation);
	} else if (strcmp (method_name, "ActivateWithHints") == 0) {
		_dbus_unity_protocol_lens_service_activate_with_hints (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdatePreviewProperty") == 0) {
		_dbus_unity_protocol_lens_service_update_preview_property (object, parameters, invocation);
	} else if (strcmp (method_name, "Search") == 0) {
		_dbus_unity_protocol_lens_service_search (object, parameters, invocation);
	} else if (strcmp (method_name, "GlobalSearch") == 0) {
		_dbus_unity_protocol_lens_service_global_search (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdateFilter") == 0) {
		_dbus_unity_protocol_lens_service_update_filter (object, parameters, invocation);
	} else if (strcmp (method_name, "SetViewType") == 0) {
		_dbus_unity_protocol_lens_service_set_view_type (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* unity_protocol_lens_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean unity_protocol_lens_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_unity_protocol_lens_service_changed (GObject* _sender, UnityProtocolLensInfo* lens_info, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp128_;
	GVariantBuilder _tmp129_;
	GHashTableIter _tmp130_;
	gpointer _tmp131_;
	gpointer _tmp132_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp128_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).dbus_path));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_boolean ((*lens_info).search_in_global));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_boolean ((*lens_info).visible));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).search_hint));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).private_connection_name));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).results_model_name));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).global_results_model_name));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).categories_model_name));
	g_variant_builder_add_value (&_tmp128_, g_variant_new_string ((*lens_info).filters_model_name));
	g_hash_table_iter_init (&_tmp130_, (*lens_info).hints);
	g_variant_builder_init (&_tmp129_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp130_, &_tmp131_, &_tmp132_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp131_;
		_value = (GVariant*) _tmp132_;
		g_variant_builder_add (&_tmp129_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp128_, g_variant_builder_end (&_tmp129_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp128_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.Unity.Lens", "Changed", _arguments, NULL);
}


guint unity_protocol_lens_service_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_unity_protocol_lens_service_dbus_interface_info), &_unity_protocol_lens_service_dbus_interface_vtable, data, _unity_protocol_lens_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_unity_protocol_lens_service_changed, data);
	return result;
}


static void _unity_protocol_lens_service_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_unity_protocol_lens_service_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}



