/* protocol-scope-interface.c generated by valac 0.22.1, the Vala compiler
 * generated from protocol-scope-interface.vala, do not modify */

/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define UNITY_PROTOCOL_TYPE_SCOPE_INFO (unity_protocol_scope_info_get_type ())
typedef struct _UnityProtocolScopeInfo UnityProtocolScopeInfo;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define UNITY_PROTOCOL_TYPE_ACTIVATION_REPLY_RAW (unity_protocol_activation_reply_raw_get_type ())
typedef struct _UnityProtocolActivationReplyRaw UnityProtocolActivationReplyRaw;

#define UNITY_PROTOCOL_TYPE_SCOPE_SERVICE (unity_protocol_scope_service_get_type ())
#define UNITY_PROTOCOL_SCOPE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, UnityProtocolScopeService))
#define UNITY_PROTOCOL_IS_SCOPE_SERVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE))
#define UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, UnityProtocolScopeServiceIface))

typedef struct _UnityProtocolScopeService UnityProtocolScopeService;
typedef struct _UnityProtocolScopeServiceIface UnityProtocolScopeServiceIface;

#define UNITY_PROTOCOL_TYPE_SCOPE_SERVICE_PROXY (unity_protocol_scope_service_proxy_get_type ())
typedef GDBusProxy UnityProtocolScopeServiceProxy;
typedef GDBusProxyClass UnityProtocolScopeServiceProxyClass;

struct _UnityProtocolScopeInfo {
	gchar* dbus_path;
	GVariant* sources;
	gboolean search_in_global;
	gchar* private_connection_name;
	gchar* results_model_name;
	gchar* global_results_model_name;
	gchar* filters_model_name;
	GHashTable* hints;
};

struct _UnityProtocolActivationReplyRaw {
	gchar* uri;
	guint handled;
	GHashTable* hints;
};

typedef enum  {
	UNITY_PROTOCOL_SCOPE_ERROR_SEARCH_CANCELLED,
	UNITY_PROTOCOL_SCOPE_ERROR_UNKNOWN
} UnityProtocolScopeError;
#define UNITY_PROTOCOL_SCOPE_ERROR unity_protocol_scope_error_quark ()
struct _UnityProtocolScopeServiceIface {
	GTypeInterface parent_iface;
	void (*info_request) (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*info_request_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*activate) (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
	void (*update_preview_property) (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*update_preview_property_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*search) (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*search_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*global_search) (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*global_search_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*set_view_type) (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_view_type_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
	void (*set_active_sources) (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_active_sources_finish) (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
};



GType unity_protocol_scope_info_get_type (void) G_GNUC_CONST;
UnityProtocolScopeInfo* unity_protocol_scope_info_dup (const UnityProtocolScopeInfo* self);
void unity_protocol_scope_info_free (UnityProtocolScopeInfo* self);
void unity_protocol_scope_info_copy (const UnityProtocolScopeInfo* self, UnityProtocolScopeInfo* dest);
void unity_protocol_scope_info_destroy (UnityProtocolScopeInfo* self);
GType unity_protocol_activation_reply_raw_get_type (void) G_GNUC_CONST;
UnityProtocolActivationReplyRaw* unity_protocol_activation_reply_raw_dup (const UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_free (UnityProtocolActivationReplyRaw* self);
void unity_protocol_activation_reply_raw_copy (const UnityProtocolActivationReplyRaw* self, UnityProtocolActivationReplyRaw* dest);
void unity_protocol_activation_reply_raw_destroy (UnityProtocolActivationReplyRaw* self);
GQuark unity_protocol_scope_error_quark (void);
GType unity_protocol_scope_service_proxy_get_type (void) G_GNUC_CONST;
guint unity_protocol_scope_service_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType unity_protocol_scope_service_get_type (void) G_GNUC_CONST;
void unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_activate (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
void unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_protocol_scope_service_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
void unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_protocol_scope_service_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void unity_protocol_scope_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_unity_protocol_scope_service_changed (UnityProtocolScopeService* self, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void unity_protocol_scope_service_proxy_info_request_async (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_activate_async (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error);
static void unity_protocol_scope_service_proxy_update_preview_property_async (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_global_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
static GHashTable* unity_protocol_scope_service_proxy_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_set_view_type_async (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_set_active_sources_async (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void unity_protocol_scope_service_proxy_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error);
static void unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init (UnityProtocolScopeServiceIface* iface);
static void _dbus_unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_activate (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_unity_protocol_scope_service_set_active_sources_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void unity_protocol_scope_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* unity_protocol_scope_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean unity_protocol_scope_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_unity_protocol_scope_service_changed (GObject* _sender, UnityProtocolScopeInfo* lens_info, gpointer* _data);
static void _unity_protocol_scope_service_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusErrorEntry unity_protocol_scope_error_entries[] = {{UNITY_PROTOCOL_SCOPE_ERROR_SEARCH_CANCELLED, "com.canonical.Unity.ScopeError.SearchCancelled"}, {UNITY_PROTOCOL_SCOPE_ERROR_UNKNOWN, "com.canonical.Unity.ScopeError.Unknown"}};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_info_request_in[] = {NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_info_request_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_info_request = {-1, "InfoRequest", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_info_request_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_info_request_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_action_type = {-1, "action_type", "u"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_activate_result = {-1, "result", "(sua{sv})"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_activate_in[] = {&_unity_protocol_scope_service_dbus_arg_info_activate_uri, &_unity_protocol_scope_service_dbus_arg_info_activate_action_type, &_unity_protocol_scope_service_dbus_arg_info_activate_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_activate_out[] = {&_unity_protocol_scope_service_dbus_arg_info_activate_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_activate = {-1, "Activate", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_activate_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_activate_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_uri = {-1, "uri", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_values = {-1, "values", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_update_preview_property_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_update_preview_property_in[] = {&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_uri, &_unity_protocol_scope_service_dbus_arg_info_update_preview_property_values, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_update_preview_property_out[] = {&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_update_preview_property = {-1, "UpdatePreviewProperty", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_update_preview_property_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_search_in[] = {&_unity_protocol_scope_service_dbus_arg_info_search_search_string, &_unity_protocol_scope_service_dbus_arg_info_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_search_out[] = {&_unity_protocol_scope_service_dbus_arg_info_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_search = {-1, "Search", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_search_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_search_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_search_string = {-1, "search_string", "s"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_hints = {-1, "hints", "a{sv}"};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_global_search_result = {-1, "result", "a{sv}"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_global_search_in[] = {&_unity_protocol_scope_service_dbus_arg_info_global_search_search_string, &_unity_protocol_scope_service_dbus_arg_info_global_search_hints, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_global_search_out[] = {&_unity_protocol_scope_service_dbus_arg_info_global_search_result, NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_global_search = {-1, "GlobalSearch", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_global_search_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_global_search_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_set_view_type_view_type = {-1, "view_type", "u"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_view_type_in[] = {&_unity_protocol_scope_service_dbus_arg_info_set_view_type_view_type, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_view_type_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_set_view_type = {-1, "SetViewType", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_view_type_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_view_type_out)};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_set_active_sources_sources = {-1, "sources", "as"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_active_sources_in[] = {&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_sources, NULL};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_set_active_sources_out[] = {NULL};
static const GDBusMethodInfo _unity_protocol_scope_service_dbus_method_info_set_active_sources = {-1, "SetActiveSources", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_in), (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_set_active_sources_out)};
static const GDBusMethodInfo * const _unity_protocol_scope_service_dbus_method_info[] = {&_unity_protocol_scope_service_dbus_method_info_info_request, &_unity_protocol_scope_service_dbus_method_info_activate, &_unity_protocol_scope_service_dbus_method_info_update_preview_property, &_unity_protocol_scope_service_dbus_method_info_search, &_unity_protocol_scope_service_dbus_method_info_global_search, &_unity_protocol_scope_service_dbus_method_info_set_view_type, &_unity_protocol_scope_service_dbus_method_info_set_active_sources, NULL};
static const GDBusArgInfo _unity_protocol_scope_service_dbus_arg_info_changed_lens_info = {-1, "lens_info", "(svbssssa{sv})"};
static const GDBusArgInfo * const _unity_protocol_scope_service_dbus_arg_info_changed[] = {&_unity_protocol_scope_service_dbus_arg_info_changed_lens_info, NULL};
static const GDBusSignalInfo _unity_protocol_scope_service_dbus_signal_info_changed = {-1, "Changed", (GDBusArgInfo **) (&_unity_protocol_scope_service_dbus_arg_info_changed)};
static const GDBusSignalInfo * const _unity_protocol_scope_service_dbus_signal_info[] = {&_unity_protocol_scope_service_dbus_signal_info_changed, NULL};
static const GDBusPropertyInfo * const _unity_protocol_scope_service_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _unity_protocol_scope_service_dbus_interface_info = {-1, "com.canonical.Unity.Scope", (GDBusMethodInfo **) (&_unity_protocol_scope_service_dbus_method_info), (GDBusSignalInfo **) (&_unity_protocol_scope_service_dbus_signal_info), (GDBusPropertyInfo **) (&_unity_protocol_scope_service_dbus_property_info)};
static const GDBusInterfaceVTable _unity_protocol_scope_service_dbus_interface_vtable = {unity_protocol_scope_service_dbus_interface_method_call, unity_protocol_scope_service_dbus_interface_get_property, unity_protocol_scope_service_dbus_interface_set_property};

static gpointer _g_variant_ref0 (gpointer self) {
	return self ? g_variant_ref (self) : NULL;
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


void unity_protocol_scope_info_copy (const UnityProtocolScopeInfo* self, UnityProtocolScopeInfo* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GVariant* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	GHashTable* _tmp13_ = NULL;
	GHashTable* _tmp14_ = NULL;
	_tmp0_ = (*self).dbus_path;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).dbus_path);
	(*dest).dbus_path = _tmp1_;
	_tmp2_ = (*self).sources;
	_tmp3_ = _g_variant_ref0 (_tmp2_);
	_g_variant_unref0 ((*dest).sources);
	(*dest).sources = _tmp3_;
	_tmp4_ = (*self).search_in_global;
	(*dest).search_in_global = _tmp4_;
	_tmp5_ = (*self).private_connection_name;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 ((*dest).private_connection_name);
	(*dest).private_connection_name = _tmp6_;
	_tmp7_ = (*self).results_model_name;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 ((*dest).results_model_name);
	(*dest).results_model_name = _tmp8_;
	_tmp9_ = (*self).global_results_model_name;
	_tmp10_ = g_strdup (_tmp9_);
	_g_free0 ((*dest).global_results_model_name);
	(*dest).global_results_model_name = _tmp10_;
	_tmp11_ = (*self).filters_model_name;
	_tmp12_ = g_strdup (_tmp11_);
	_g_free0 ((*dest).filters_model_name);
	(*dest).filters_model_name = _tmp12_;
	_tmp13_ = (*self).hints;
	_tmp14_ = _g_hash_table_ref0 (_tmp13_);
	_g_hash_table_unref0 ((*dest).hints);
	(*dest).hints = _tmp14_;
}


void unity_protocol_scope_info_destroy (UnityProtocolScopeInfo* self) {
	_g_free0 ((*self).dbus_path);
	_g_variant_unref0 ((*self).sources);
	_g_free0 ((*self).private_connection_name);
	_g_free0 ((*self).results_model_name);
	_g_free0 ((*self).global_results_model_name);
	_g_free0 ((*self).filters_model_name);
	_g_hash_table_unref0 ((*self).hints);
}


UnityProtocolScopeInfo* unity_protocol_scope_info_dup (const UnityProtocolScopeInfo* self) {
	UnityProtocolScopeInfo* dup;
	dup = g_new0 (UnityProtocolScopeInfo, 1);
	unity_protocol_scope_info_copy (self, dup);
	return dup;
}


void unity_protocol_scope_info_free (UnityProtocolScopeInfo* self) {
	unity_protocol_scope_info_destroy (self);
	g_free (self);
}


GType unity_protocol_scope_info_get_type (void) {
	static volatile gsize unity_protocol_scope_info_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_scope_info_type_id__volatile)) {
		GType unity_protocol_scope_info_type_id;
		unity_protocol_scope_info_type_id = g_boxed_type_register_static ("UnityProtocolScopeInfo", (GBoxedCopyFunc) unity_protocol_scope_info_dup, (GBoxedFreeFunc) unity_protocol_scope_info_free);
		g_once_init_leave (&unity_protocol_scope_info_type_id__volatile, unity_protocol_scope_info_type_id);
	}
	return unity_protocol_scope_info_type_id__volatile;
}


void unity_protocol_activation_reply_raw_copy (const UnityProtocolActivationReplyRaw* self, UnityProtocolActivationReplyRaw* dest) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	GHashTable* _tmp3_ = NULL;
	GHashTable* _tmp4_ = NULL;
	_tmp0_ = (*self).uri;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).uri);
	(*dest).uri = _tmp1_;
	_tmp2_ = (*self).handled;
	(*dest).handled = _tmp2_;
	_tmp3_ = (*self).hints;
	_tmp4_ = _g_hash_table_ref0 (_tmp3_);
	_g_hash_table_unref0 ((*dest).hints);
	(*dest).hints = _tmp4_;
}


void unity_protocol_activation_reply_raw_destroy (UnityProtocolActivationReplyRaw* self) {
	_g_free0 ((*self).uri);
	_g_hash_table_unref0 ((*self).hints);
}


UnityProtocolActivationReplyRaw* unity_protocol_activation_reply_raw_dup (const UnityProtocolActivationReplyRaw* self) {
	UnityProtocolActivationReplyRaw* dup;
	dup = g_new0 (UnityProtocolActivationReplyRaw, 1);
	unity_protocol_activation_reply_raw_copy (self, dup);
	return dup;
}


void unity_protocol_activation_reply_raw_free (UnityProtocolActivationReplyRaw* self) {
	unity_protocol_activation_reply_raw_destroy (self);
	g_free (self);
}


GType unity_protocol_activation_reply_raw_get_type (void) {
	static volatile gsize unity_protocol_activation_reply_raw_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_activation_reply_raw_type_id__volatile)) {
		GType unity_protocol_activation_reply_raw_type_id;
		unity_protocol_activation_reply_raw_type_id = g_boxed_type_register_static ("UnityProtocolActivationReplyRaw", (GBoxedCopyFunc) unity_protocol_activation_reply_raw_dup, (GBoxedFreeFunc) unity_protocol_activation_reply_raw_free);
		g_once_init_leave (&unity_protocol_activation_reply_raw_type_id__volatile, unity_protocol_activation_reply_raw_type_id);
	}
	return unity_protocol_activation_reply_raw_type_id__volatile;
}


GQuark unity_protocol_scope_error_quark (void) {
	static volatile gsize unity_protocol_scope_error_quark_volatile = 0;
	g_dbus_error_register_error_domain ("unity_protocol_scope_error-quark", &unity_protocol_scope_error_quark_volatile, unity_protocol_scope_error_entries, G_N_ELEMENTS (unity_protocol_scope_error_entries));
	return (GQuark) unity_protocol_scope_error_quark_volatile;
}


void unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->info_request (self, _callback_, _user_data_);
}


void unity_protocol_scope_service_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->info_request_finish (self, _res_, error);
}


void unity_protocol_scope_service_activate (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->activate (self, uri, action_type, hints, _callback_, _user_data_);
}


void unity_protocol_scope_service_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->activate_finish (self, _res_, result, error);
}


void unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->update_preview_property (self, uri, values, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->update_preview_property_finish (self, _res_, error);
}


void unity_protocol_scope_service_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->search_finish (self, _res_, error);
}


void unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->global_search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_protocol_scope_service_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	return UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->global_search_finish (self, _res_, error);
}


void unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_view_type (self, view_type, _callback_, _user_data_);
}


void unity_protocol_scope_service_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_view_type_finish (self, _res_, error);
}


void unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_active_sources (self, sources, sources_length1, _callback_, _user_data_);
}


void unity_protocol_scope_service_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	UNITY_PROTOCOL_SCOPE_SERVICE_GET_INTERFACE (self)->set_active_sources_finish (self, _res_, error);
}


static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), data2);
}


static void unity_protocol_scope_service_base_init (UnityProtocolScopeServiceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("changed", UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, UNITY_PROTOCOL_TYPE_SCOPE_INFO);
	}
}


/**
 * ScopeService:
 *
 * The Scope interface exported on DBus
 */
GType unity_protocol_scope_service_get_type (void) {
	static volatile gsize unity_protocol_scope_service_type_id__volatile = 0;
	if (g_once_init_enter (&unity_protocol_scope_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityProtocolScopeServiceIface), (GBaseInitFunc) unity_protocol_scope_service_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_protocol_scope_service_type_id;
		unity_protocol_scope_service_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityProtocolScopeService", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_protocol_scope_service_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) unity_protocol_scope_service_proxy_get_type);
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.canonical.Unity.Scope");
		g_type_set_qdata (unity_protocol_scope_service_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) unity_protocol_scope_service_register_object);
		g_once_init_leave (&unity_protocol_scope_service_type_id__volatile, unity_protocol_scope_service_type_id);
	}
	return unity_protocol_scope_service_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (UnityProtocolScopeServiceProxy, unity_protocol_scope_service_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (UNITY_PROTOCOL_TYPE_SCOPE_SERVICE, unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init) )
static void unity_protocol_scope_service_proxy_class_init (UnityProtocolScopeServiceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = unity_protocol_scope_service_proxy_g_signal;
}


static void _dbus_handle_unity_protocol_scope_service_changed (UnityProtocolScopeService* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	UnityProtocolScopeInfo lens_info = {0};
	GVariant* _tmp133_;
	UnityProtocolScopeInfo _tmp134_;
	GVariantIter _tmp135_;
	GVariant* _tmp136_;
	GVariant* _tmp137_;
	GVariant* _tmp138_;
	GVariant* _tmp139_;
	GVariant* _tmp140_;
	GVariant* _tmp141_;
	GVariant* _tmp142_;
	GVariant* _tmp143_;
	GHashTable* _tmp144_;
	GVariantIter _tmp145_;
	GVariant* _tmp146_;
	GVariant* _tmp147_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp133_ = g_variant_iter_next_value (&_arguments_iter);
	g_variant_iter_init (&_tmp135_, _tmp133_);
	_tmp136_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.dbus_path = g_variant_dup_string (_tmp136_, NULL);
	g_variant_unref (_tmp136_);
	_tmp137_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.sources = g_variant_get_variant (_tmp137_);
	g_variant_unref (_tmp137_);
	_tmp138_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.search_in_global = g_variant_get_boolean (_tmp138_);
	g_variant_unref (_tmp138_);
	_tmp139_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.private_connection_name = g_variant_dup_string (_tmp139_, NULL);
	g_variant_unref (_tmp139_);
	_tmp140_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.results_model_name = g_variant_dup_string (_tmp140_, NULL);
	g_variant_unref (_tmp140_);
	_tmp141_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.global_results_model_name = g_variant_dup_string (_tmp141_, NULL);
	g_variant_unref (_tmp141_);
	_tmp142_ = g_variant_iter_next_value (&_tmp135_);
	_tmp134_.filters_model_name = g_variant_dup_string (_tmp142_, NULL);
	g_variant_unref (_tmp142_);
	_tmp143_ = g_variant_iter_next_value (&_tmp135_);
	_tmp144_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp145_, _tmp143_);
	while (g_variant_iter_loop (&_tmp145_, "{?*}", &_tmp146_, &_tmp147_)) {
		g_hash_table_insert (_tmp144_, g_variant_dup_string (_tmp146_, NULL), g_variant_get_variant (_tmp147_));
	}
	_tmp134_.hints = _tmp144_;
	g_variant_unref (_tmp143_);
	lens_info = _tmp134_;
	g_variant_unref (_tmp133_);
	g_signal_emit_by_name (self, "changed", &lens_info);
	unity_protocol_scope_info_destroy (&lens_info);
}


static void unity_protocol_scope_service_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "Changed") == 0) {
		_dbus_handle_unity_protocol_scope_service_changed ((UnityProtocolScopeService*) proxy, parameters);
	}
}


static void unity_protocol_scope_service_proxy_init (UnityProtocolScopeServiceProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void unity_protocol_scope_service_proxy_info_request_async (UnityProtocolScopeService* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "InfoRequest");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_info_request_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_activate_async (UnityProtocolScopeService* self, const gchar* uri, guint action_type, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp148_;
	GHashTableIter _tmp149_;
	gpointer _tmp150_;
	gpointer _tmp151_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "Activate");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (action_type));
	g_hash_table_iter_init (&_tmp149_, hints);
	g_variant_builder_init (&_tmp148_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp149_, &_tmp150_, &_tmp151_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp150_;
		_value = (GVariant*) _tmp151_;
		g_variant_builder_add (&_tmp148_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp148_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_activate_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, UnityProtocolActivationReplyRaw* result, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GVariant* _tmp152_;
	UnityProtocolActivationReplyRaw _tmp153_;
	GVariantIter _tmp154_;
	GVariant* _tmp155_;
	GVariant* _tmp156_;
	GVariant* _tmp157_;
	GHashTable* _tmp158_;
	GVariantIter _tmp159_;
	GVariant* _tmp160_;
	GVariant* _tmp161_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp152_ = g_variant_iter_next_value (&_reply_iter);
	g_variant_iter_init (&_tmp154_, _tmp152_);
	_tmp155_ = g_variant_iter_next_value (&_tmp154_);
	_tmp153_.uri = g_variant_dup_string (_tmp155_, NULL);
	g_variant_unref (_tmp155_);
	_tmp156_ = g_variant_iter_next_value (&_tmp154_);
	_tmp153_.handled = g_variant_get_uint32 (_tmp156_);
	g_variant_unref (_tmp156_);
	_tmp157_ = g_variant_iter_next_value (&_tmp154_);
	_tmp158_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp159_, _tmp157_);
	while (g_variant_iter_loop (&_tmp159_, "{?*}", &_tmp160_, &_tmp161_)) {
		g_hash_table_insert (_tmp158_, g_variant_dup_string (_tmp160_, NULL), g_variant_get_variant (_tmp161_));
	}
	_tmp153_.hints = _tmp158_;
	g_variant_unref (_tmp157_);
	*result = _tmp153_;
	g_variant_unref (_tmp152_);
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_update_preview_property_async (UnityProtocolScopeService* self, const gchar* uri, GHashTable* values, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp162_;
	GHashTableIter _tmp163_;
	gpointer _tmp164_;
	gpointer _tmp165_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "UpdatePreviewProperty");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	g_hash_table_iter_init (&_tmp163_, values);
	g_variant_builder_init (&_tmp162_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp163_, &_tmp164_, &_tmp165_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp164_;
		_value = (GVariant*) _tmp165_;
		g_variant_builder_add (&_tmp162_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp162_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_update_preview_property_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp166_;
	GHashTable* _tmp167_;
	GVariantIter _tmp168_;
	GVariant* _tmp169_;
	GVariant* _tmp170_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp166_ = g_variant_iter_next_value (&_reply_iter);
	_tmp167_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp168_, _tmp166_);
	while (g_variant_iter_loop (&_tmp168_, "{?*}", &_tmp169_, &_tmp170_)) {
		g_hash_table_insert (_tmp167_, g_variant_dup_string (_tmp169_, NULL), g_variant_get_variant (_tmp170_));
	}
	_result = _tmp167_;
	g_variant_unref (_tmp166_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp171_;
	GHashTableIter _tmp172_;
	gpointer _tmp173_;
	gpointer _tmp174_;
	G_IO_ERROR;
	UNITY_PROTOCOL_SCOPE_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "Search");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp172_, hints);
	g_variant_builder_init (&_tmp171_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp172_, &_tmp173_, &_tmp174_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp173_;
		_value = (GVariant*) _tmp174_;
		g_variant_builder_add (&_tmp171_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp171_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp175_;
	GHashTable* _tmp176_;
	GVariantIter _tmp177_;
	GVariant* _tmp178_;
	GVariant* _tmp179_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp175_ = g_variant_iter_next_value (&_reply_iter);
	_tmp176_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp177_, _tmp175_);
	while (g_variant_iter_loop (&_tmp177_, "{?*}", &_tmp178_, &_tmp179_)) {
		g_hash_table_insert (_tmp176_, g_variant_dup_string (_tmp178_, NULL), g_variant_get_variant (_tmp179_));
	}
	_result = _tmp176_;
	g_variant_unref (_tmp175_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_global_search_async (UnityProtocolScopeService* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp180_;
	GHashTableIter _tmp181_;
	gpointer _tmp182_;
	gpointer _tmp183_;
	G_IO_ERROR;
	UNITY_PROTOCOL_SCOPE_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "GlobalSearch");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (search_string));
	g_hash_table_iter_init (&_tmp181_, hints);
	g_variant_builder_init (&_tmp180_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp181_, &_tmp182_, &_tmp183_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp182_;
		_value = (GVariant*) _tmp183_;
		g_variant_builder_add (&_tmp180_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp180_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static GHashTable* unity_protocol_scope_service_proxy_global_search_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	GHashTable* _result;
	GVariant* _tmp184_;
	GHashTable* _tmp185_;
	GVariantIter _tmp186_;
	GVariant* _tmp187_;
	GVariant* _tmp188_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp184_ = g_variant_iter_next_value (&_reply_iter);
	_tmp185_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp186_, _tmp184_);
	while (g_variant_iter_loop (&_tmp186_, "{?*}", &_tmp187_, &_tmp188_)) {
		g_hash_table_insert (_tmp185_, g_variant_dup_string (_tmp187_, NULL), g_variant_get_variant (_tmp188_));
	}
	_result = _tmp185_;
	g_variant_unref (_tmp184_);
	g_object_unref (_reply_message);
	return _result;
}


static void unity_protocol_scope_service_proxy_set_view_type_async (UnityProtocolScopeService* self, guint view_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "SetViewType");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (view_type));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_set_view_type_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_set_active_sources_async (UnityProtocolScopeService* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp189_;
	GVariantBuilder _tmp190_;
	int _tmp191_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.canonical.Unity.Scope", "SetActiveSources");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp189_ = sources;
	g_variant_builder_init (&_tmp190_, G_VARIANT_TYPE ("as"));
	for (_tmp191_ = 0; _tmp191_ < sources_length1; _tmp191_++) {
		g_variant_builder_add_value (&_tmp190_, g_variant_new_string (*_tmp189_));
		_tmp189_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp190_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void unity_protocol_scope_service_proxy_set_active_sources_finish (UnityProtocolScopeService* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_proxy_unity_protocol_scope_service_interface_init (UnityProtocolScopeServiceIface* iface) {
	iface->info_request = unity_protocol_scope_service_proxy_info_request_async;
	iface->info_request_finish = unity_protocol_scope_service_proxy_info_request_finish;
	iface->activate = unity_protocol_scope_service_proxy_activate_async;
	iface->activate_finish = unity_protocol_scope_service_proxy_activate_finish;
	iface->update_preview_property = unity_protocol_scope_service_proxy_update_preview_property_async;
	iface->update_preview_property_finish = unity_protocol_scope_service_proxy_update_preview_property_finish;
	iface->search = unity_protocol_scope_service_proxy_search_async;
	iface->search_finish = unity_protocol_scope_service_proxy_search_finish;
	iface->global_search = unity_protocol_scope_service_proxy_global_search_async;
	iface->global_search_finish = unity_protocol_scope_service_proxy_global_search_finish;
	iface->set_view_type = unity_protocol_scope_service_proxy_set_view_type_async;
	iface->set_view_type_finish = unity_protocol_scope_service_proxy_set_view_type_finish;
	iface->set_active_sources = unity_protocol_scope_service_proxy_set_active_sources_async;
	iface->set_active_sources_finish = unity_protocol_scope_service_proxy_set_active_sources_finish;
}


static void _dbus_unity_protocol_scope_service_info_request (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	unity_protocol_scope_service_info_request (self, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_info_request_ready, invocation);
}


static void _dbus_unity_protocol_scope_service_info_request_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_info_request_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_activate (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp192_;
	guint action_type = 0U;
	GVariant* _tmp193_;
	GHashTable* hints = NULL;
	GVariant* _tmp194_;
	GHashTable* _tmp195_;
	GVariantIter _tmp196_;
	GVariant* _tmp197_;
	GVariant* _tmp198_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp192_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp192_, NULL);
	g_variant_unref (_tmp192_);
	_tmp193_ = g_variant_iter_next_value (&_arguments_iter);
	action_type = g_variant_get_uint32 (_tmp193_);
	g_variant_unref (_tmp193_);
	_tmp194_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp195_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp196_, _tmp194_);
	while (g_variant_iter_loop (&_tmp196_, "{?*}", &_tmp197_, &_tmp198_)) {
		g_hash_table_insert (_tmp195_, g_variant_dup_string (_tmp197_, NULL), g_variant_get_variant (_tmp198_));
	}
	hints = _tmp195_;
	g_variant_unref (_tmp194_);
	unity_protocol_scope_service_activate (self, uri, action_type, hints, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_activate_ready, invocation);
	_g_free0 (uri);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_scope_service_activate_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	UnityProtocolActivationReplyRaw result = {0};
	GVariantBuilder _tmp199_;
	GVariantBuilder _tmp200_;
	GHashTableIter _tmp201_;
	gpointer _tmp202_;
	gpointer _tmp203_;
	invocation = _user_data_;
	unity_protocol_scope_service_activate_finish ((UnityProtocolScopeService*) source_object, _res_, &result, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp199_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp199_, g_variant_new_string (result.uri));
	g_variant_builder_add_value (&_tmp199_, g_variant_new_uint32 (result.handled));
	g_hash_table_iter_init (&_tmp201_, result.hints);
	g_variant_builder_init (&_tmp200_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp201_, &_tmp202_, &_tmp203_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp202_;
		_value = (GVariant*) _tmp203_;
		g_variant_builder_add (&_tmp200_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp199_, g_variant_builder_end (&_tmp200_));
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp199_));
	unity_protocol_activation_reply_raw_destroy (&result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_update_preview_property (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp204_;
	GHashTable* values = NULL;
	GVariant* _tmp205_;
	GHashTable* _tmp206_;
	GVariantIter _tmp207_;
	GVariant* _tmp208_;
	GVariant* _tmp209_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp204_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp204_, NULL);
	g_variant_unref (_tmp204_);
	_tmp205_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp206_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp207_, _tmp205_);
	while (g_variant_iter_loop (&_tmp207_, "{?*}", &_tmp208_, &_tmp209_)) {
		g_hash_table_insert (_tmp206_, g_variant_dup_string (_tmp208_, NULL), g_variant_get_variant (_tmp209_));
	}
	values = _tmp206_;
	g_variant_unref (_tmp205_);
	unity_protocol_scope_service_update_preview_property (self, uri, values, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_update_preview_property_ready, invocation);
	_g_free0 (uri);
	_g_hash_table_unref0 (values);
}


static void _dbus_unity_protocol_scope_service_update_preview_property_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp210_;
	GHashTableIter _tmp211_;
	gpointer _tmp212_;
	gpointer _tmp213_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_update_preview_property_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp211_, result);
	g_variant_builder_init (&_tmp210_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp211_, &_tmp212_, &_tmp213_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp212_;
		_value = (GVariant*) _tmp213_;
		g_variant_builder_add (&_tmp210_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp210_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp214_;
	GHashTable* hints = NULL;
	GVariant* _tmp215_;
	GHashTable* _tmp216_;
	GVariantIter _tmp217_;
	GVariant* _tmp218_;
	GVariant* _tmp219_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp214_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp214_, NULL);
	g_variant_unref (_tmp214_);
	_tmp215_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp216_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp217_, _tmp215_);
	while (g_variant_iter_loop (&_tmp217_, "{?*}", &_tmp218_, &_tmp219_)) {
		g_hash_table_insert (_tmp216_, g_variant_dup_string (_tmp218_, NULL), g_variant_get_variant (_tmp219_));
	}
	hints = _tmp216_;
	g_variant_unref (_tmp215_);
	unity_protocol_scope_service_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_scope_service_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp220_;
	GHashTableIter _tmp221_;
	gpointer _tmp222_;
	gpointer _tmp223_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_search_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp221_, result);
	g_variant_builder_init (&_tmp220_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp221_, &_tmp222_, &_tmp223_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp222_;
		_value = (GVariant*) _tmp223_;
		g_variant_builder_add (&_tmp220_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp220_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_global_search (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* search_string = NULL;
	GVariant* _tmp224_;
	GHashTable* hints = NULL;
	GVariant* _tmp225_;
	GHashTable* _tmp226_;
	GVariantIter _tmp227_;
	GVariant* _tmp228_;
	GVariant* _tmp229_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp224_ = g_variant_iter_next_value (&_arguments_iter);
	search_string = g_variant_dup_string (_tmp224_, NULL);
	g_variant_unref (_tmp224_);
	_tmp225_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp226_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, NULL);
	g_variant_iter_init (&_tmp227_, _tmp225_);
	while (g_variant_iter_loop (&_tmp227_, "{?*}", &_tmp228_, &_tmp229_)) {
		g_hash_table_insert (_tmp226_, g_variant_dup_string (_tmp228_, NULL), g_variant_get_variant (_tmp229_));
	}
	hints = _tmp226_;
	g_variant_unref (_tmp225_);
	unity_protocol_scope_service_global_search (self, search_string, hints, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_global_search_ready, invocation);
	_g_free0 (search_string);
	_g_hash_table_unref0 (hints);
}


static void _dbus_unity_protocol_scope_service_global_search_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	GHashTable* result;
	GVariantBuilder _tmp230_;
	GHashTableIter _tmp231_;
	gpointer _tmp232_;
	gpointer _tmp233_;
	invocation = _user_data_;
	result = unity_protocol_scope_service_global_search_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp231_, result);
	g_variant_builder_init (&_tmp230_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp231_, &_tmp232_, &_tmp233_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp232_;
		_value = (GVariant*) _tmp233_;
		g_variant_builder_add (&_tmp230_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp230_));
	_g_hash_table_unref0 (result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_set_view_type (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	guint view_type = 0U;
	GVariant* _tmp234_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp234_ = g_variant_iter_next_value (&_arguments_iter);
	view_type = g_variant_get_uint32 (_tmp234_);
	g_variant_unref (_tmp234_);
	unity_protocol_scope_service_set_view_type (self, view_type, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_set_view_type_ready, invocation);
}


static void _dbus_unity_protocol_scope_service_set_view_type_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_set_view_type_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_unity_protocol_scope_service_set_active_sources (UnityProtocolScopeService* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar** sources = NULL;
	int sources_length1 = 0;
	GVariant* _tmp235_;
	gchar** _tmp236_;
	int _tmp236__length;
	int _tmp236__size;
	int _tmp236__length1;
	GVariantIter _tmp237_;
	GVariant* _tmp238_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp235_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp236_ = g_new (gchar*, 5);
	_tmp236__length = 0;
	_tmp236__size = 4;
	_tmp236__length1 = 0;
	g_variant_iter_init (&_tmp237_, _tmp235_);
	for (; (_tmp238_ = g_variant_iter_next_value (&_tmp237_)) != NULL; _tmp236__length1++) {
		if (_tmp236__size == _tmp236__length) {
			_tmp236__size = 2 * _tmp236__size;
			_tmp236_ = g_renew (gchar*, _tmp236_, _tmp236__size + 1);
		}
		_tmp236_[_tmp236__length++] = g_variant_dup_string (_tmp238_, NULL);
		g_variant_unref (_tmp238_);
	}
	sources_length1 = _tmp236__length1;
	_tmp236_[_tmp236__length] = NULL;
	sources = _tmp236_;
	g_variant_unref (_tmp235_);
	unity_protocol_scope_service_set_active_sources (self, sources, sources_length1, (GAsyncReadyCallback) _dbus_unity_protocol_scope_service_set_active_sources_ready, invocation);
	sources = (_vala_array_free (sources, sources_length1, (GDestroyNotify) g_free), NULL);
}


static void _dbus_unity_protocol_scope_service_set_active_sources_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	unity_protocol_scope_service_set_active_sources_finish ((UnityProtocolScopeService*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void unity_protocol_scope_service_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "InfoRequest") == 0) {
		_dbus_unity_protocol_scope_service_info_request (object, parameters, invocation);
	} else if (strcmp (method_name, "Activate") == 0) {
		_dbus_unity_protocol_scope_service_activate (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdatePreviewProperty") == 0) {
		_dbus_unity_protocol_scope_service_update_preview_property (object, parameters, invocation);
	} else if (strcmp (method_name, "Search") == 0) {
		_dbus_unity_protocol_scope_service_search (object, parameters, invocation);
	} else if (strcmp (method_name, "GlobalSearch") == 0) {
		_dbus_unity_protocol_scope_service_global_search (object, parameters, invocation);
	} else if (strcmp (method_name, "SetViewType") == 0) {
		_dbus_unity_protocol_scope_service_set_view_type (object, parameters, invocation);
	} else if (strcmp (method_name, "SetActiveSources") == 0) {
		_dbus_unity_protocol_scope_service_set_active_sources (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* unity_protocol_scope_service_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean unity_protocol_scope_service_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_unity_protocol_scope_service_changed (GObject* _sender, UnityProtocolScopeInfo* lens_info, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp239_;
	GVariantBuilder _tmp240_;
	GHashTableIter _tmp241_;
	gpointer _tmp242_;
	gpointer _tmp243_;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_init (&_tmp239_, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_tmp239_, g_variant_new_string ((*lens_info).dbus_path));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_variant ((*lens_info).sources));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_boolean ((*lens_info).search_in_global));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_string ((*lens_info).private_connection_name));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_string ((*lens_info).results_model_name));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_string ((*lens_info).global_results_model_name));
	g_variant_builder_add_value (&_tmp239_, g_variant_new_string ((*lens_info).filters_model_name));
	g_hash_table_iter_init (&_tmp241_, (*lens_info).hints);
	g_variant_builder_init (&_tmp240_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp241_, &_tmp242_, &_tmp243_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp242_;
		_value = (GVariant*) _tmp243_;
		g_variant_builder_add (&_tmp240_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_tmp239_, g_variant_builder_end (&_tmp240_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp239_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.canonical.Unity.Scope", "Changed", _arguments, NULL);
}


guint unity_protocol_scope_service_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_unity_protocol_scope_service_dbus_interface_info), &_unity_protocol_scope_service_dbus_interface_vtable, data, _unity_protocol_scope_service_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "changed", (GCallback) _dbus_unity_protocol_scope_service_changed, data);
	return result;
}


static void _unity_protocol_scope_service_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_unity_protocol_scope_service_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



