/* unity-lens-merge-strategy.c generated by valac 0.22.1, the Vala compiler
 * generated from unity-lens-merge-strategy.vala, do not modify */

/*
 * Copyright (C) 2012 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Mikkel Kamstrup Erlandsen <mikkel.kamstrup@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include "unity.h"
#include <dee.h>






/**
   * Virtual method to merge row from source model into target model.
   *
   * @param target The target model to merge a row into
   * @param row An array of variants with the row data for the result
   *
   * @return A model iter pointing to the row in the target model where @row
   *         was added. Or null if the result was discarded
   */
DeeModelIter* unity_merge_strategy_merge_result (UnityMergeStrategy* self, DeeModel* target, GVariant** row, int row_length1) {
	g_return_val_if_fail (self != NULL, NULL);
	return UNITY_MERGE_STRATEGY_GET_INTERFACE (self)->merge_result (self, target, row, row_length1);
}


static void unity_merge_strategy_base_init (UnityMergeStrategyIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType unity_merge_strategy_get_type (void) {
	static volatile gsize unity_merge_strategy_type_id__volatile = 0;
	if (g_once_init_enter (&unity_merge_strategy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityMergeStrategyIface), (GBaseInitFunc) unity_merge_strategy_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_merge_strategy_type_id;
		unity_merge_strategy_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityMergeStrategy", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_merge_strategy_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&unity_merge_strategy_type_id__volatile, unity_merge_strategy_type_id);
	}
	return unity_merge_strategy_type_id__volatile;
}



